/******************************************************************************
 *
 * $Id:$
 *
 * Copyright (C) 2000 by Dimitri van Heesch.
 *
 * Permission to use, copy, modify, and distribute this software and its
 * documentation under the terms of the GNU General Public License is hereby 
 * granted. No representations are made about the suitability of this software 
 * for any purpose. It is provided "as is" without express or implied warranty.
 * See the GNU General Public License for more details.
 *
 * The custom help code in this file was contributed by Mike Copperwhite.
 */
#if !defined(AFX_DOXCFG_H__C3FFA6E4_AE6D_11D3_813C_005056820166__INCLUDED_)
#define AFX_DOXCFG_H__C3FFA6E4_AE6D_11D3_813C_005056820166__INCLUDED_

#if _MSC_VER > 1000
#pragma once
#endif // _MSC_VER > 1000
// DoxCfg.h : header file
//

struct CustomHelpOptions;

/////////////////////////////////////////////////////////////////////////////
// DoxCfg dialog

/*! \brief Dialog to configure doxbar. 
 *
 *  Settings are retrieved and stored in the system registry.
 */
class DoxCfg : public CDialog
{
// Construction
public:
	/*! Creates the dialog.
	 *  \param options array of settings. One entry for each help command
	 */
	DoxCfg(CustomHelpOptions *options, CWnd* pParent = NULL);   // standard constructor

// Dialog Data
	//{{AFX_DATA(DoxCfg)
	enum { IDD = IDD_DOXCFG_DIALOG };
	CString	m_strCmdTool;
	CString	m_strDoxConfigTempl;
	CString	m_strDoxExe;
	CString	m_strHTMLHelpComp;
	CString	m_strUsrBatFile;
	int		m_curHelpCmdIndex;
	//}}AFX_DATA
    
	int m_curSelection;

// Overrides
	// ClassWizard generated virtual function overrides
	//{{AFX_VIRTUAL(DoxCfg)
	protected:
	virtual void DoDataExchange(CDataExchange* pDX);    // DDX/DDV support
	//}}AFX_VIRTUAL

// Implementation
protected:

	// Generated message map functions
	//{{AFX_MSG(DoxCfg)
	virtual void OnOK();
	afx_msg void OnDoxCfgButton();
	afx_msg void OnDoxExeButton();
	afx_msg void OnHelpCompButton();
	virtual BOOL OnInitDialog();
	afx_msg void OnSelendokHelpcmdcombo();
	afx_msg void OnHelpcmdcheck1();
	afx_msg void OnHelpcmdcheck2();
	afx_msg void OnHelpcmdcheck3();
	afx_msg void OnHelpCmdButton();
	afx_msg void OnChangeHelpCmdEdit();
	//}}AFX_MSG
	DECLARE_MESSAGE_MAP()

private:
	
	CustomHelpOptions *m_options;
};

//{{AFX_INSERT_LOCATION}}
// Microsoft Visual C++ will insert additional declarations immediately before the previous line.

#endif // !defined(AFX_DOXCFG_H__C3FFA6E4_AE6D_11D3_813C_005056820166__INCLUDED_)
